/***************************************************************************
                          pronews.c  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Felix Gertz
    email                : felix_gertz@das-fluppt.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

#include "catch.h"
#include "user.h"
#include "pronews.h"


char data_array[30][1500];
char newsfile_path[255];
char browser_file[255];
int akt_rate;
unsigned char onoff_status;
unsigned char onoff_status_default;
unsigned char first_time;

unsigned char first_start()
{
	char *dirname=NULL;
		
	dirname=get_homedir();
	strcat(dirname,"/.pronews");
	
	if(mkdir(dirname,0) == 0)
	{
		chmod(dirname,0755);
		set_default_config();
		
		return 1;
	}
  return 0;
}

void save_first()
{
	FILE *data_file;
	char *filename=NULL;
		
	filename=get_homedir();
	strcat(filename,"/.pronews/first");
	
	if((data_file = fopen(filename,"w")) == NULL) {
		printf("Kann nicht ffnen!\n");
		} else {
		fprintf(data_file,"0\n");
		fclose(data_file);
		}
}

unsigned char no_first_file()
{
	FILE *data_file;
	char *firstfile=NULL;
	
	firstfile=get_homedir();
	strcat(firstfile,"/.pronews/first");
	
	if((data_file = fopen(firstfile,"r")) == NULL)
		return 1;
  else
		fclose(data_file);
		
	return 0;
}

/*************************************************************
* int new_news                                               *
**************************************************************
* Returns <                                                  *
* 1000: Fehlerhafte URL                                      *
* 1: Neue News                                               *
* 0: Keine neuen News                                        *
* Sonst: Sonstiger Netzwerkfehler                            *
**************************************************************
* Prft nach neuen News und schreibt sie bei Erfolg.         *
*************************************************************/

int new_news()
{
	FILE *data_file;
	char *lengthfile=NULL;
	int old_lg,new_lg,ret;
	
	lengthfile=get_homedir();
	strcat(lengthfile,"/.pronews/length");
	
	if((data_file = fopen(lengthfile,"r")) == NULL) {
		printf("Kann Datei nicht ffnen!\n"); }
		else
		{
			fscanf(data_file,"%d",&old_lg);
			fclose(data_file);
			
			ret=get_length(&new_lg);
			if(ret) return ret;
			else
			{
				if(new_lg != old_lg)
				{
					char content[20480];
				
					ret=get_file(content);
					if(ret) return ret;
					save_file(content);
					
					save_length(new_lg);

					return 1;
				}
			}
		}
				
		return 0;
}

/*************************************************************
* get_lines                                                  *
**************************************************************
* IN >                                                       *
* line                                                       *
* OUT <                                                      *
* size                                                       *
**************************************************************
* Hohlt die Abschnitte(line) aus dem Pro-Linux Newsfile      *
* und schreibt sie in das globale Array data_array.          *
* size ist die Grsse des Arrays in Abschnitten.             *
*************************************************************/

void get_lines(unsigned char line,int *size)
{
	FILE *data_file;
	char *newsfile=NULL;
	char data[1500];
	char c;
	int cnt=0,sector=0,i;
	
	newsfile=get_homedir();
	strcat(newsfile,"/.pronews/newsfile");
	
	if((data_file = fopen(newsfile,"r")) == NULL) {
		printf("Kann Datei nicht ffnen!\n");
		} else {
			do
			{
				i=0;
				while((c=getc(data_file)) != EOF && c != '\n')
				{
					if(c==''){
						data[i++]='u';
						data[i++]='e';
					} else if(c==''){
						data[i++]='a';
						data[i++]='e';
					} else if(c==''){
						data[i++]='o';
						data[i++]='e';
					} else
					data[i++]=c;
				}
				data[i]='\0';
				cnt++;
				if(!(strcmp(data,"%%"))) sector++;
				if((cnt-6*sector)==line) strcpy(data_array[sector],data);
			}	while (c != EOF);	
			fclose(data_file);
		}	
		*size=sector;
}

void set_default_config()
{
	FILE *data_file;
	char *configfile=NULL;
	
	configfile=get_homedir();
	strcat(configfile,"/.pronews/configfile");
	
	if((data_file = fopen(configfile,"w")) == NULL) {
		printf("Kann nicht ffnen!\n");
		} else {
		fprintf(data_file,"0\n");
		fprintf(data_file,"180\n");
		fprintf(data_file,"http://www.pro-linux.de:80/news/news1.txt\n");
		fprintf(data_file,"netscape\n");
		fclose(data_file);
		}
}

/*************************************************************
* pronews_config_init                                        *
**************************************************************
* Liest die config und setzt die globalen config-Variablen.  *
*************************************************************/

void pronews_config_init()
{
	FILE *data_file;
	char *configfile=NULL;
	char data[255];
	char c;
	int cnt=0,i;
	
	configfile=get_homedir();
	strcat(configfile,"/.pronews/configfile");
	
	if((data_file = fopen(configfile,"r")) == NULL) {
		printf("Kann nicht ffnen!\n");
		} else {
		do
			{
				i=0;
				while((c=getc(data_file)) != EOF && c != '\n')
				{
					data[i++]=c;
				}
				data[i]='\0';
				cnt++;
				if(cnt==1) {onoff_status=strtol(data,NULL,10); onoff_status_default=onoff_status; }
				if(cnt==2) akt_rate=strtol(data,NULL,10);
				if(cnt==3) strcpy(newsfile_path,data);
				if(cnt==4) strcpy(browser_file,data);
			}	while (c != EOF);	
		if(akt_rate<180) akt_rate=180;
		fclose(data_file);
		}
}